RegisterAddonMessagePrefix("ZygorLinkTarget")
ZygorLinkTargets = {}

local split = function(string)
	local tab = {}
	for w in string.gmatch(string,"[^\$]+") do
		table.insert(tab,w)
	end
	return unpack(tab)
end
--ends
local broadcast = function()
	local guide = ZGV.CurrentGuideName --string.gsub(ZGV.CurrentGuideName,"\\","\\\\")
	local step = ZGV.CurrentStepNum
	for _,target in pairs(ZygorLinkTargets) do
		SendAddonMessage("ZygorLinkTarget",guide.."$"..step,"WHISPER",target)
	end
end

local frame = CreateFrame("Frame")
frame:RegisterEvent("CHAT_MSG_ADDON")
frame:SetScript("OnEvent",
	function(tab,event,prefix,msg,chattype,from)
		if prefix=="ZygorLinkTarget" then
			--print(prefix)
			--print(from)
			--print(ZygorLinkTarget)
			--print(msg)
			if msg=="Link" then
				local alreadylinked=0
				if #ZygorLinkTargets~=0 then
					for _,target in pairs(ZygorLinkTargets) do
						--print(target)
						if from==target then
							alreadylinked=1
						end
					end
				end
				if alreadylinked==0 then
					table.insert(ZygorLinkTargets,from)
				end
				SendAddonMessage("ZygorLinkTarget","Established","WHISPER",from)
			elseif msg=="Established" then
				print(ZygorLinkTarget.." Linked!")
			else
				if from==ZygorLinkTarget then
					local guide,step = split(msg)
					--print(guide.." "..step)

					---[[
					ZGV:SetGuide(guide,step)
					ZGV.pause = true
					--]]

				end
			end
		end
	end
)

local old = ZGV.FocusStep
ZGV.FocusStep = function(num,forcefocus)
	old(num,forcefocus)
	broadcast()
end

SLASH_ZygorLinkSet1 = "/zl"
function ZygorLinkSet()
	if UnitName("target")~=nil and UnitName("target")~=UnitName("player") then
		--print("now")
		local target,tarrealm = UnitName("target")
		local tarrealm = tarrealm or GetRealmName()
		if tarrealm=="" then tarrealm = GetRealmName() end
		ZygorLinkTarget = target.."-"..tarrealm
		print("Attempting to link to "..ZygorLinkTarget.."...")
		SendAddonMessage("ZygorLinkTarget","Link","WHISPER",ZygorLinkTarget)
		--print(ZygorLinkTarget)
		--print("end")
	elseif UnitName("target")==UnitName("player") then
		print("WARNING:Linking yourself is a bad idea. This will set the guide to the step you're already on, and in doing so try to change the step to what you're already on. It will then trigger a response to yourself that you have changed steps causing a never-ending loop that will freeze your WoW client.")
	else
		if ZygorLinkTarget==nil then
			print("No target")
		else
			ZygorLinkTarget=nil
			print("Zygor Link Cleared!")
		end
	end
end
SlashCmdList["ZygorLinkSet"] = ZygorLinkSet
